#!/usr/bin/perl
#######################
##  AutoRank v2.0.0  ##
###################################################################################
##  CREATED ON   :  July 11, 1998                                                ##
##  LAST UPDATED :  June 29, 1999                                                ##
##  E-MAIL       :  scripts@cgi-works.net                                        ##
##  WEB SITE     :  http://www.cgi-works.net                                     ##
###################################################################################
##               COPYRIGHT  1998 CGI WORKS. ALL RIGHTS RESERVED                 ##
###################################################################################
##  This portion of the header appears only in this script file, but applies     ##
##  to all of the scripts that make up this software package.                    ##
##                                                                               ##
##  Copyright Notice                                                             ##
##  ----------------                                                             ##
##  Any redistribution of this script without                                    ##
##  the written consent of CGI Works is strictly prohibited.  Copying            ##
##  any of the code contained within these scripts and claiming it as your       ##
##  own is also prohibited.  You may not remove any of these header notices.     ##
##  By using this code you agree to indemnify CGI Works from any                 ##
##  liability that might arise from it's use.                                    ##
###################################################################################
##  functions.cgi                                                                ##
##  -------------                                                                ##
##  This file contains functions common to most of the scripts.                  ##
###################################################################################

package FUNCTIONS;
use strict;

###################################################################################
#                             DO NOT EDIT THIS FILE                               # 
###################################################################################

$FUNCTIONS::SCRIPT_DATA_DIR = "./sdata";
require "$FUNCTIONS::SCRIPT_DATA_DIR/variables.dat" if(-e "$FUNCTIONS::SCRIPT_DATA_DIR/variables.dat");
$FUNCTIONS::VERSION_NUMBER = "2.0.0";
$FUNCTIONS::CURRENT_DATE = get_date();
$FUNCTIONS::CURRENT = 0;
1;

sub get_date {	
  my @time_breakdown = localtime;
  my $time_of_day = "am";
  
  for(0..3) { $time_breakdown[$_] = 0 . $time_breakdown[$_] if(length($time_breakdown[$_]) < 2); } 
  
  $time_breakdown[4]++;
  ($time_breakdown[2] -= 12 and $time_of_day = "pm") if($time_breakdown[2] > 12);  ## Convert to non-military clock
  $time_breakdown[5] += 1900;  

  return "$time_breakdown[2]:$time_breakdown[1]:$time_breakdown[0]$time_of_day $time_breakdown[4]/$time_breakdown[3]/$time_breakdown[5]";
}

sub parse {
  my ($remove_html) = shift;
  my ($value, $name, $buffer);
  %FUNCTIONS::FORM = ();
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  my @pairs = split(/&/, $buffer);
	
  for (@pairs) {
    ($name, $value) = split(/=/, $_);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/<([^>]|\n)*>//g if($remove_html);
    $FUNCTIONS::FORM{$name} = $value;
  }
}

sub parse_query {
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  my ($name, $value);
  %FUNCTIONS::QUERY = ();
  
  for (@pairs) {
    ($name, $value) = split(/=/, $_);
    $FUNCTIONS::QUERY{$name} = $value;
  }
}

sub load_member_data {
  my %member_hash = ();

  opendir(MEMBER_DIR, "$VARIABLES::MEMBER_DATA_DIR") || FUNCTIONS::script_error(1003, $VARIABLES::MEMBER_DATA_DIR);
  my @member_files = sort(grep { m/.*\.mdf/ } readdir(MEMBER_DIR));
  closedir(MEMBER_DIR);

  for(@member_files) {
    open(MEMBER_FILE, "$VARIABLES::MEMBER_DATA_DIR/$_");
    $member_hash{$_} = (split(/\|/, <MEMBER_FILE>))[0];
    close(MEMBER_FILE);
  }

  return (sort { $member_hash{$FUNCTIONS::b} <=> $member_hash{$FUNCTIONS::a} } keys %member_hash);
}

############################################################
##  Altering/Removing this code is a copyright violation  ##
############################################################
sub cgi_works_footer {
  my($fh) = shift;
  $fh = *STDOUT if(!$fh);
  print $fh <<HTML;
  <center>
  <hr width="30\%" size="1" noshade>
  <font face="Verdana,Arial" size="-2">
  Powered By <a href="http://www.cgi-works.net">AutoRank v$FUNCTIONS::VERSION_NUMBER</a>
  </body>
  </html>
HTML
}

sub header {
  my ($title, $fh) = @_;
  $fh = *STDOUT if(!$fh);
  print $fh <<HTML;
  <html>
  <head>
    <title>$title</title>
  <body bgcolor="white" link="blue">
  <div align="center">
HTML
}

sub open_table {
  my ($title, $fh, $csp, $width) = @_;
  $fh = *STDOUT if(!$fh);
  $width = 600 unless($width);
  print $fh <<TABLE_OPEN;
  <table cellpadding="1" cellspacing="0" border="0" align="center" width="$width">
  <tr>
  <td bgcolor="#000000">
  <!-- INNER TABLE --> 
  <table cellpadding="5" cellspacing="1" border="0" width="100\%">
  <tr>
  <td bgcolor="#afafaf" align="center" colspan="$csp">
  <font face="Verdana,Arial" size="4">
  <b>$title</b>
  </font>
  </td>
  </tr>
TABLE_OPEN
}

sub close_table {
  my($fh) = @_;
  $fh = *STDOUT if(!$fh);	
  print $fh <<TABLE_CLOSE;
  </table>
  </td></tr></table><p>
TABLE_CLOSE
}

sub password_is_valid {
  my $entered_password = shift;
  open(PASS, "$FUNCTIONS::SCRIPT_DATA_DIR/admin.epf") || FUNCTIONS::script_error(1002, "admin.epf");
  my $crypt_password = <PASS>;
  close(PASS);

  my $crypt_entered_password = crypt($entered_password, "aa");

  return "$crypt_password" eq "$crypt_entered_password" 
}

sub print_the_list {
  my(@sorted_members) = @_;
  my $members = scalar(@sorted_members);
  my $who = "";
  my $rank = 0;
  $VARIABLES::SITES_TO_LIST = @sorted_members if($VARIABLES::SITES_TO_LIST > @sorted_members);

  open(LIST, ">$VARIABLES::HTML_DIR/autorank.html") || script_error(1001, "autorank.html");
  
  if(-e "$FUNCTIONS::SCRIPT_DATA_DIR/header.txt") {
    open(HEADER, "$FUNCTIONS::SCRIPT_DATA_DIR/header.txt");
    while(<HEADER>) {  print LIST  }
    close(HEADER);
  }

  print LIST qq|<table border="$TABLE::BORDER" |;
  print LIST qq|cellspacing="$TABLE::CSPACING" |;
  print LIST qq|cellpadding="$TABLE::CPADDING" |;
  print LIST qq|width="$TABLE::WIDTH">\n|;
  print LIST qq|<tr bgcolor="$TABLE::TOP_BG_COLOR">\n|;
  print LIST qq|<td align="center">\n|;
  print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE"><b>&nbsp;RANK&nbsp;</b></font>|;
  print LIST qq|</td>\n|;
  print LIST qq|<td align="center">\n|;
  print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE"><b>SITE</b></font>|;
  print LIST qq|</td>\n|;
  print LIST qq|<td align="center">\n|;
  print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE"><b>&nbsp;&nbsp;IN&nbsp;&nbsp;</b></font>|;
  print LIST qq|</td>\n<td align="center">\n|;
  print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE"><b>&nbsp;OUT&nbsp;</b></font>|;
  print LIST qq|</td></tr>\n|;


  for ($rank = 1; $rank <= $VARIABLES::SITES_TO_LIST; $rank++) {    
    open (MEMBER, "$VARIABLES::MEMBER_DATA_DIR/$sorted_members[($rank - 1)]") || script_error(1004, "$sorted_members[($rank - 1)]");
    my ($in, $out, $totalIn, $inactive, $url, $title, $descrip, $email, $banner, $password) = split (/\|/, <MEMBER>);
    close (MEMBER);
      
    $who = $sorted_members[($rank - 1)];
    $who =~ s/\.mdf//gi;
      
    if ($in >= $VARIABLES::MINIMUM_HITS) {
      print LIST qq|<tr bgcolor="$TABLE::BG_COLOR">\n|;
      print LIST qq|<td align="center">\n|;
      print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE">$rank</font>\n|;
      print LIST qq|</td>\n|;
      print LIST qq|<td align="center">\n|;
      print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE">\n|;
      print LIST qq|<a href="$VARIABLES::CGI_URL/out.cgi?$who" target="$VARIABLES::TARGET">|;
      print LIST qq|<img src="$banner" border="0" height="$VARIABLES::BANNER_HEIGHT" width="$VARIABLES::BANNER_WIDTH"><br>| if($rank <= $VARIABLES::NUM_OF_BANNERS && $banner);       
      print LIST qq|$title</a><br>$descrip</td>\n|;
      print LIST qq|<td align="center">\n|;
      print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE">$in</td>\n|;
      print LIST qq|<td align="center">|;
      print LIST qq|<font face="$TABLE::FONT_FACE" size="$TABLE::FONT_SIZE">$out</td></tr>|;        
    }
  }

  print LIST qq|</table><p><font face="Verdana,Arial" size="1">Last Updated: $FUNCTIONS::CURRENT_DATE<br>|;
  print LIST qq|$members Sites In Our Database</font><p>|;
  
  if(-e "$FUNCTIONS::SCRIPT_DATA_DIR/footer.txt") {
    open(FOOTER, "$FUNCTIONS::SCRIPT_DATA_DIR/footer.txt");
    while(<FOOTER>) {  print LIST  }
    close(FOOTER);
  }
  
  &cgi_works_footer(*LIST);

  close(LIST);
}

sub script_error {
  my($code_number, $file, $error) = @_;
  $error = $!;
  $error = "Unknown" if($error eq "");
  
  print "Content-type: text/html\n\n";
  
  unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/errors.dat") {
    print "Cannot locate errors.dat file!";
    exit;
  }
  require "$FUNCTIONS::SCRIPT_DATA_DIR/errors.dat";
  
  header("A Script Error Has Occured");
  open_table("Script Error With $file");
  print <<HTML;
  <tr>
  <td bgcolor="#dcdcdc" align="center"><font face="verdana" size="2">
  $SCRIPT_ERRORS::CODE{$code_number}
  </td>
  </tr>
  <tr>
  <td bgcolor="#ffffff" align="center">
  <font face="verdana" size="1"><b>Error Cause:</b> $error
  </td></tr>
HTML
  close_table();
  exit;
}

sub data_error {
  my($code_number, $data) = @_;
  unless(-e "$FUNCTIONS::SCRIPT_DATA_DIR/errors.dat") {
    print "Cannot locate errors.dat file!";
    exit;
  }
  require "$FUNCTIONS::SCRIPT_DATA_DIR/errors.dat";
  
  header("A Data Error Has Occured");
  open_table("<font color=blue>Data Error:</font> $data");
  print <<HTML;
  <tr>
  <td bgcolor="#dcdcdc" align="center"><font face="verdana" size="2">
  $DATA_ERRORS::CODE{$code_number}
  </td></tr>
HTML
  close_table();
  exit;
}
