#!/usr/bin/perl
#######################
##  AutoRank v2.0.0  ##
###################################################################################
##  out.cgi                                                                      ##
##  -------                                                                      ##
##  This script controls the counting of outgoing hits from the list.            ##
###################################################################################

use strict;
package OUT;

###################################################################################
#                             DO NOT EDIT THIS FILE                               #
###################################################################################

$OUT::SCRIPT_DATA_DIR = "./sdata";
OUT::problem("Could not load the variables file") unless(-e "$OUT::SCRIPT_DATA_DIR/variables.dat");

require "$OUT::SCRIPT_DATA_DIR/variables.dat";

sub LOCK_SH { 1 }
sub LOCK_EX { 2 }
sub LOCK_NB { 4 }
sub LOCK_UN { 8 }

&giveOutHit($ENV{'QUERY_STRING'});
exit;

sub giveOutHit {
  my($id) = shift;
  if(-e "$VARIABLES::MEMBER_DATA_DIR/$id.mdf") {
    open(DATA, "+<$VARIABLES::MEMBER_DATA_DIR/$id.mdf") || OUT::problem("Could not open member datafile");
    
    unless(flock(DATA, LOCK_SH | LOCK_NB)) {
      unless(flock(DATA, LOCK_SH)) { die "flock: $!\n"; }
    }
    
    my ($in, $out, $totalIn, $inactive, $url, $title, $descrip, $email, $banner, $password) = split(/\|/, <DATA>);
    
    flock(DATA, LOCK_UN);
    
    $out++;
    
    unless(flock(DATA, LOCK_EX | LOCK_NB)) {
      unless(flock(DATA, LOCK_EX)) { die "flock: $!\n"; }
    }
    
    truncate(DATA, 0);
    seek(DATA, 0, 0);
    print DATA "$in|$out|$totalIn|$inactive|$url|$title|$descrip|$email|$banner|$password";
    flock(DATA, LOCK_UN);
    close(DATA);

    print "Location: $url\n\n";  
  }
  else {
    print "Content-type: text/html\n\n";
    print "No member exists with that ID!";
  }
}

sub problem {
  my $description = shift;
  print "Content-type: text/html\n\n";
  print "$description\n";
  print "$!";
  exit;
}
